package org.enhydra.dm.business;

import org.enhydra.dm.api.AppUser;
import org.enhydra.dm.api.exceptions.BaseException;
import org.enhydra.dm.business.exceptions.DatabaseException;
import org.enhydra.dm.data.AppUserDO;

import com.lutris.appserver.server.sql.DatabaseManagerException;
import com.lutris.appserver.server.sql.ObjectIdException;
import com.lutris.dods.builder.generator.query.DataObjectException;

/**
 * Implementation of AppUser interface.
 * 
 * @author Svjetlana Milidrag
 */

public class AppUserImpl implements AppUser {

   String id;

   String firstname;

   String lastname;

   String username;

   String password;

   String role;

   public AppUserImpl() {

   }

   public AppUserImpl(AppUserDO userDO) throws BaseException {
      try {
         setId(userDO.get_OId().toString());
         setFirstname(userDO.getFIRSTNAME());
         setLastname(userDO.getLASTNAME());
         setUsername(userDO.getUSERNAME());
         setPassword(userDO.getPASSWORD());
         setRole(userDO.getROLE());
      } catch (Exception e) {
         throw new DatabaseException(e);
      }
   }

   public String getFirstname() {
      return firstname;
   }

   public void setFirstname(String firstname) {
      this.firstname = firstname;
   }

   public String getLastname() {
      return lastname;
   }

   public void setLastname(String lastname) {
      this.lastname = lastname;
   }

   public String getId() {
      return id;
   }

   public void setId(String id) {
      this.id = id;
   }

   public String getPassword() {
      return password;
   }

   public void setPassword(String password) {
      this.password = password;
   }

   public String getRole() {
      return role;
   }

   public void setRole(String role) {
      this.role = role;
   }

   public String getUsername() {
      return username;
   }

   public void setUsername(String username) {
      this.username = username;
   }

   public AppUserDO createDO() throws BaseException {
      try {
         AppUserDO userDO = AppUserDO.createVirgin();
         userDO.setFIRSTNAME(this.getFirstname());
         userDO.setLASTNAME(this.getLastname());
         userDO.setUSERNAME(this.getUsername());
         userDO.setPASSWORD(this.getPassword());
         userDO.setROLE(this.getRole());

         return userDO;
      } catch (DatabaseManagerException e) {
         throw new DatabaseException(e);
      } catch (ObjectIdException e) {
         throw new DatabaseException(e);
      } catch (DataObjectException e) {
         throw new DatabaseException(e);
      }
   }
}
