package org.enhydra.dm.business;

import org.enhydra.dm.api.FoDocument;
import org.enhydra.dm.api.FoDocumentParam;
import org.enhydra.dm.api.exceptions.BaseException;
import org.enhydra.dm.data.FoDocumentDO;
import org.enhydra.dm.data.FoDocumentParamDO;

import com.lutris.appserver.server.sql.DatabaseManagerException;
import com.lutris.appserver.server.sql.ObjectIdException;
import com.lutris.dods.builder.generator.query.DataObjectException;

/**
 * Implementation of FoDocumentParam interface.
 * 
 * @author Zorica Dudarin
 */

public class FoDocumentParamImpl implements FoDocumentParam {

   String id;

   String name;

   String content;

   FoDocument foDocumentRef = null;

   public FoDocumentParamImpl() {

   }

   public FoDocumentParamImpl(FoDocumentParamDO foDocumentParamDO) throws BaseException {
      try {
         setId(foDocumentParamDO.get_OId().toString());
         setName(foDocumentParamDO.getNAME());
         setContent(foDocumentParamDO.getCONTENT());

         FoDocumentDO foDocDO = foDocumentParamDO.getFODOCUMENTREF();
         if (foDocDO != null) {
            setFoDocumentRef((FoDocument) new FoDocumentImpl(foDocDO));
         }
      } catch (Exception e) {
         throw new BaseException(e);
      }
   }

   public FoDocumentParamImpl(String id) throws BaseException {
      try {
         setId(id);
      } catch (Exception e) {
         throw new BaseException(e);
      }
   }

   public String getId() {
      return id;
   }

   public void setId(String id) {
      this.id = id;
   }

   public FoDocumentParamDO createDO() throws BaseException {
      try {
         FoDocumentParamDO foDocumentParamDo = FoDocumentParamDO.createVirgin();
         foDocumentParamDo.setNAME(getName());
         foDocumentParamDo.setCONTENT(getContent());

         return foDocumentParamDo;
      } catch (DatabaseManagerException e) {
         throw new BaseException(e);
      } catch (ObjectIdException e) {
         throw new BaseException(e);
      } catch (DataObjectException e) {
         throw new BaseException(e);
      }
   }

   public String getContent() {
      return content;
   }

   public String getName() {
      return name;
   }

   public void setContent(String content) {
      this.content = content;
   }

   public void setName(String name) {
      this.name = name;
   }

   public FoDocument getFoDocumentRef() {
      return this.foDocumentRef;
   }

   public void setFoDocumentRef(FoDocument foDocumentRef) {
      this.foDocumentRef = foDocumentRef;
   }
}
