/*
 * This type of presentation object could be the target of a form's submit
 * button, process the data, and then decide where to send the user (back or on to the
 * next page).
 */

package org.enhydra.dm.presentation;

import org.enhydra.dm.util.EnhydraDMConstants;
import org.enhydra.dm.EnhydraDM;


import com.lutris.appserver.server.httpPresentation.HttpPresentationComms;

public class Upload extends Base {

   /*
    * There is the only function needed in order to be a presentation object.
    */
   public void run(HttpPresentationComms comms) throws Exception {
      UploadHTML page = (UploadHTML) comms.xmlcFactory.create(UploadHTML.class);
      
      comms.request.getHttpServletRequest().setCharacterEncoding(EnhydraDMConstants.ENCODING);

      String documentid = comms.request.getParameter(EnhydraDMConstants.DOCUMENT_ID);
      String mode = comms.request.getParameter(EnhydraDMConstants.MODE);
      String user = getUser(comms);
      
      if (!EnhydraDMConstants.MODE_TEMPLATE.equals(mode)) {
         mode = EnhydraDMConstants.MODE_DOCUMENT;
      }

      page.getElementDocumentId().setValue(documentid);
      page.getElementAction().setValue(EnhydraDMConstants.ACTION_CHECKIN);
      page.getElementUserId().setValue(user);
      page.getElementMode().setValue(mode);
      page.getElementAllowedExtensions().setValue(EnhydraDM.allowedExtensionsForUpload);
      
      page.getElementBackLink().setHref(EnhydraDMConstants.NAVIG_MANAGER + "?" + EnhydraDMConstants.MODE + "=" + mode);

      comms.response.writeDOM(page);
   }

}
