/**
 * 
 */
package org.enhydra.dm.api;

import org.enhydra.dm.api.exceptions.BaseException;
import org.enhydra.dm.data.DocumentVersionDO;

/**
 * DocumentVersion interface that represents association with
 * DocumentVersionDO object with additional business functionality extensions.
 * 
 * @author Slobodan Vujasinovic
 */
public interface DocumentVersion {

   public Document getDocument();

   public void setDocument(Document document);

   public String getFilepath();

   public void setFilepath(String filepath);

   public String getLastModifiedBy();

   public void setLastModifiedBy(String lastModifiedBy);

   public long getLastModifiedDate();

   public void setLastModifiedDate(long lastModifiedDate);

   public String getNumber();

   public void setNumber(String number);

   public String getId();

   public void setId(String id);

   public long getSize();

   public void setSize(long size);

   public long getVersionDate();

   public void setVersionDate(long versionDate);

   public FoDocument getFoDocumentRef();

   public void setFoDocumentRef(FoDocument foDocumentRef);

   public String getVersionNumber();

   public void setVersionNumber(String versionNumber);

   public DocumentVersionDO createVersionDO() throws BaseException;
}
