package org.enhydra.dm.api;

import org.enhydra.dm.api.exceptions.BaseException;
import org.enhydra.dm.data.FoDocumentDO;

/**
 * FoDocument interface that represents association with FoDocumentDO
 * object with additional business functionality extensions.
 * 
 * @author Zorica Dudarin
 */
public interface FoDocument {

   public String getId();

   public void setId(String id);

   public String getUserPassword();

   public void setUserPassword(String userPassword);

   public String getOwnerPassword();

   public void setOwnerPassword(String ownerPassword);

   public boolean isAllowPrint();

   public void setAllowPrint(boolean allowPrint);

   public boolean isAllowCopyContent();

   public void setAllowCopyContent(boolean allowCopyContent);

   public boolean isAllowEditContent();

   public void setAllowEditContent(boolean allowEditContent);

   public boolean isAllowEditAnnotation();

   public void setAllowEditAnnotation(boolean allowEditAnnotation);

   public FoDocumentDO createDO() throws BaseException;
}
