package org.enhydra.dm.api;

import java.util.Map;

import org.enhydra.dm.api.exceptions.BaseException;
import org.enhydra.dm.api.loggers.Log;

public interface FoDocumentManager {

   /**
    * Method that creates foDocument in database.
    * 
    * @param name
    * @param date
    * @param subject
    * @param content
    * @param userPwd
    * @param ownerPwd
    * @param allowPrint
    * @param allowCopyContent
    * @param allowEditContent
    * @param allowEditAnnotations
    * @return foDocumentOid
    * @throws BaseException
    */
   public String create(Map parameters,
                        String userPwd,
                        String ownerPwd,
                        boolean allowPrint,
                        boolean allowCopyContent,
                        boolean allowEditContent,
                        boolean allowEditAnnotations) throws BaseException;

   /**
    * Method to get foDocument from database by foDocument id.
    * 
    * @param id
    * @return
    * @throws BaseException
    */
   public FoDocument getFoDocumentById(String id) throws BaseException;
   
   /**
    * Method to get foDocument parameters from database by foDocument id.
    * 
    * @param id
    * @return
    * @throws BaseException
    */
   public FoDocumentParam [] getFoDocumentParametersById(String id) throws BaseException;

   /**
    * Getter for logger
    * 
    * @return
    */
   public Log getLogger();

   /**
    * Setter for logger
    * 
    * @param logger
    */
   public void setLogger(Log logger);
}
