package org.enhydra.dm.api;

import java.util.Properties;

import org.enhydra.dm.api.exceptions.BaseException;
import org.enhydra.dm.api.loggers.Log;

public interface UserManager {
   

   /**
    * Get user by username
    * 
    * @param username
    * @return
    * @throws BaseException
    */
   public AppUser getUserByUsername(String username) throws BaseException;

   /**
    * Get user by user id
    * 
    * @param userOid
    * @return
    * @throws BaseException
    */
   public AppUser getUserById(String userId) throws BaseException;

   /**
    * Create user in database
    * 
    * @param firstname
    * @param lastname
    * @param username
    * @param password
    * @throws BaseException
    */
   public boolean createUser(String firstname,
                          String lastname,
                          String username,
                          String password) throws BaseException;
   
   /**
    * Getter for logger
    * 
    * @return
    */
   public Log getLogger();

   /**
    * Setter for logger
    * 
    * @param logger
    */
   public void setLogger(Log logger);
   
   /**
    * Configure method that read parameters from Properties
    * 
    * @param properties
    * @throws BaseException
    */
   public void configure(Properties properties) throws BaseException;

}
