package org.enhydra.dm.api.util;

import java.util.Properties;

import org.enhydra.dm.api.exceptions.BaseException;
import org.enhydra.dm.api.loggers.Log;

import com.lutris.util.Config;

/**
 * Interface with methods for encoding functionality.
 * 
 * @author Slobodan Vujasinovic
 */

public interface DesEncription {

   /**
    * @param str
    * @param strEncoding
    * @return
    * @throws BaseException
    */
   public String encrypt(String str, String strEncoding) throws BaseException;

   /**
    * @param str
    * @return
    * @throws BaseException
    */
   public String encrypt(String str) throws BaseException;

   /**
    * @param strEncrypted
    * @param strEncoding
    * @return
    * @throws BaseException
    */
   public String decrypt(String strEncrypted, String strEncoding) throws BaseException;

   /**
    * @param strEncrypted
    * @return
    * @throws BaseException
    */
   public String decrypt(String strEncrypted) throws BaseException;

   /**
    * Getter for logger
    * 
    * @return
    */
   public Log getLogger();

   /**
    * Setter for logger
    * 
    * @param logger
    */
   public void setLogger(Log logger);

   /**
    * Configure method that reads parameters from Config
    * 
    * @param config
    * @throws BaseException
    */
   public void configure(Config config) throws BaseException;

   /**
    * Configure method that reads parameters from Properties
    * 
    * @param properties
    * @throws BaseException
    */
   public void configure(Properties properties) throws BaseException;

}
