/**
 * 
 */

package org.enhydra.dm.handler;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.enhydra.dm.api.handler.AbstractHandler;
import org.enhydra.dm.api.loggers.Log;
import org.enhydra.dm.util.EnhydraDMConstants;

/**
 * Default implementation of a handler for requests using the HTTP OPTIONS method.
 * 
 * @author Slobodan Vujasinovic
 */
public class DefaultOptionsHandler extends AbstractHandler {

   /**
    * Services requests which use the HTTP OPTIONS method. This implementation provides
    * the list of supported methods for the target resource.
    * 
    * @param request The request being serviced.
    * @param response The servlet response.
    * @throws ServletException If an application error occurs.
    * @throws IOException If an IO error occurs while handling the request.
    */

   public void service(HttpServletRequest request, HttpServletResponse response)
      throws IOException,
         ServletException {
      if (null != getLogger()) {
         getLogger().log(Log.DEBUG, "OPTIONS Request for document (id)\"{0}\".");
      }

      response.setHeader("DAV", "1,2");
      response.setHeader("MS-Author-Via", "DAV");
      response.setHeader(EnhydraDMConstants.HEAD_ALLOW, getAllowedMethods());
   }

}
