package org.enhydra.dm.loggers;

import org.enhydra.dm.api.loggers.Log;

import com.lutris.appserver.server.Enhydra;
import com.lutris.logging.LogChannel;
import com.lutris.logging.Logger;

/**
 * Enhydra Log extension for abstract Log class.
 * 
 * @author Svjetlana Milidrag
 */

public class EnhydraLog extends Log {
   LogChannel logChanel;

   protected void logMessage(int level, String message) {
      if (null == logChanel) {
         logChanel = Enhydra.getApplication().getLogChannel();
      }

      if (null != logChanel) {

         logChanel.write(mapLevels(level), message);
      }

   }

   private int mapLevels(int level) {
      int lev;
      switch (level) {
         case DEBUG:
            lev = Logger.DEBUG;
            break;
         case INFORMATION:
            lev = Logger.INFO;
            break;
         case WARNING:
            lev = Logger.WARNING;
            break;
         case ERROR:
            lev = Logger.ERROR;
            break;
         case CRITICAL:
            lev = Logger.CRITICAL;
            break;
         default:
            lev = Logger.DEBUG;
      }
      return lev;
   }

}
