package org.enhydra.dm.loggers;

import org.apache.log4j.Level;
import org.apache.log4j.Logger;
import org.enhydra.dm.api.loggers.Log;

/**
 * Log4j extension for abstract Log class.
 * 
 * @author Slobodan Vujasinovic
 */

public class Log4jLog extends Log {

   private Logger logger = null;

   protected void logMessage(int level, String message) {
      Level lev;

      if (logger == null) {
         logger = Logger.getLogger("EnhydraDM");
      }
      lev = intToLevel(level);
      if (lev == null) {
         lev = Level.INFO;
      }
      logger.log(lev, message);

   }

   private Level intToLevel(int level) {
      Level lev;

      switch (level) {
         case CRITICAL:
         case ERROR:
            lev = Level.ERROR;
            break;

         case WARNING:
            lev = Level.WARN;
            break;

         case INFORMATION:
            lev = Level.INFO;
            break;

         case DEBUG:
            lev = Level.DEBUG;
            break;

         default:
            lev = Level.DEBUG;
      }
      return lev;
   }

}
