package org.enhydra.dm.util;

import java.util.Properties;

/**
 * Mime type mapper class. Use editablemimetypes.properties with editable mime types list
 * 
 * @author Svjetlana Milidrag
 */

public class MimeUtility {
   /**
    * Methos for extracting mime type for corresponding file extension
    * 
    * @param editableMT
    * @param documentName
    * @return
    */
   public static String mimeTypeMapper(Properties editableMT, String documentName) {

      String extension = documentName.substring(documentName.lastIndexOf("."));

      return editableMT.getProperty(extension);

   }

   /**
    * Method that search for mime type in editablemimetypes.properties file.
    * 
    * @param editableMT
    * @param mimetype
    * @return true if file is editable, false otherwise
    */
   public static boolean isEditableDocument(Properties editableMT, String mimetype) {

      return editableMT.containsValue(mimetype);
   }

}
